<?php
/**
*
* @package phpBB Encrypr Passwords Mod
* @version 1.0.1
* @copyright (c) 2013 c61 http://c61.no-ip.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

function encrypt_passwords()
{
	global $template, $db;

	if (
	     defined('IN_INSTALL')
	  || !defined('HEADER_INC')
	  || !isset($template->_rootref)
	  || !(isset($template->_rootref['S_FORM_TOKEN']) || isset($template->_rootref['S_LOGIN_ACTION']))
	  || !isset($template->_rootref['DEBUG_OUTPUT'])
	   ) return;

		$path = defined('ADMIN_START') ? './../' : './';

		// Генерируем пару ключей RSA
		require_once($path . 'includes/encrypt_passwords/phpseclib/Crypt/RSA.php');

		$rsa = new Crypt_RSA();
		$rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
		extract($rsa->createKey());

		// Сохраняем ключи в базе данных
		$keys = array(
			'time'      => time(),
			'privatekey'=> $privatekey,
		);
		$sql = "INSERT INTO " . ENCRYPT_PASSWORDS_TABLE . " " . $db->sql_build_array('INSERT', $keys);
		$db->sql_query($sql);
		$ep_id = $db->sql_nextid();

		// Модифицируем public-ключ для использования в javascript
		$publickey = str_replace(array('-----BEGIN PUBLIC KEY-----',"\r\n","\r","\n",'-----END PUBLIC KEY-----'),'',$publickey);

		// Добавляем код javascript
		$template->_rootref['DEBUG_OUTPUT'] .= '
<script type="text/javascript" src="' . $path . 'styles/jsencrypt.min.js"></script>
<script type="text/javascript">
// <![CDATA[
var encrypt_passwords_id = ' . $ep_id . ';
var publickey = "' . $publickey . '";
var inputtags = document.getElementsByTagName("INPUT");
var inputpasswordtags = new Array();
var numinputpasswordtags = 0;
for ( var i=0; i<inputtags.length; i++ )
{
	switch (inputtags[i].type)
	{
		case "password":	case "PASSWORD":
		{
			// Create hidden input element
			var hidden = document.createElement("input");
			if ( hidden )
			{
				var name = "encrypt_passwords_"+numinputpasswordtags;
				inputpasswordtags[numinputpasswordtags++] = inputtags[i];
				// Add element to form
				var form = inputtags[i].form;
				hidden.type  = "hidden";
				hidden.name  = name;
				hidden.id    = name;
				hidden.value = encrypt_passwords_id + ":" + inputtags[i].name;
				form.appendChild(hidden);
				// Add submit function (unconditionally)
				form.onsubmit=function()
				{
					for ( var i=0; i<numinputpasswordtags; i++ )
					{
						var crypt = new JSEncrypt();
						crypt.setPublicKey(publickey);
						inputpasswordtags[i].value = crypt.encrypt(inputpasswordtags[i].value);
					}
					return true;
				};
			}
			break;
		}
	}
}
// ]]>
</script>
';

}

// Регистрируем хук
$phpbb_hook->register(array('template', 'display'), 'encrypt_passwords');

?>